"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildDefaultContext = exports.defaultConfig = exports.defaultCallbackPosition = void 0;
exports.defaultCallbackPosition = 'preWalk';
const defaultReport = {
    startTime: new Date(),
    callbackProcessingTime: 0,
    processed: {
        array: 0,
        object: 0,
        value: 0,
        classInstances: {}
    }
};
exports.defaultConfig = {
    traversalMode: 'depth',
    rootObjectCallbacks: true,
    runCallbacks: true,
    monitorPerformance: false,
    graphMode: 'finiteTree',
    pathFormat: (key, isArr) => isArr ? `[${key}]` : `["${key}"]`,
    callbacks: []
};
const buildDefaultContext = (config) => ({
    config: Object.assign(Object.assign({}, exports.defaultConfig), config),
    nodes: {},
    seenObjects: [],
    callbacksByPosition: {},
    report: defaultReport
});
exports.buildDefaultContext = buildDefaultContext;
